-----------------------------------------------------------------------------------------
-- Start Activity
-----------------------------------------------------------------------------------------

function AssassinationMission:StartActivity()
    print("START! -- AssassinationMission:StartActivity()!");
    --These 4 seem to be in every mission.  Not sure what they do, but I don't want to mess with them just in case they're important. 
    self.FightStage = { NOFIGHT = 0, DEFENDING = 1, ATTACK = 2, FIGHTSTAGECOUNT = 3 };
    self.AreaTimer = Timer();
    self.StepTimer = Timer();
    self.SpawnTimer = Timer();
    --This is used in any mission to determine the current stage.  NOFIGHT means that enemies won't spawn.
    self.CurrentFightStage = self.FightStage.NOFIGHT;

    --All the enterable zones that are used later.  Any zone simply used to find an object, for instance "Prison Doors 1" are defined later because they are temporary.
	escape = SceneMan.Scene:GetArea("Escape");
    --This is set to 1 while the player is in the Healing Pod.  It's used to prevent the player from being trapped inside.
    self.healed = 0;
    --The current character being played as.
    playerActor = nil;
    --This is to make sure nothing happens until the level has started.
    self.timer = 0;
    --For some reason, the game continues to run the activities after the game has ended.  This stores if it's over or not just in case that causes errors.
    varend = 0;
    --Last position of playerActor.
    lastpos = nil;
    --Whether or not the targets has been assassinated.
    assassinated = 0;
	assassinated2 = 0;
	
    --------------------------
    -- Set up teams

    -- Team 2 is always CPU
    self.CPUTeam = Activity.TEAM_2;
	ActivityMan:GetActivity():SetTeamFunds(0,0);
    
    --------------------------
    -- Set up players
    for player = 0, self.PlayerCount - 0 do
	--Set the brain to playerActor.  The only reason we do this is that the game crashes without a brain.  Even if the playerActor dies, it won't matter, though.
	pl = CreateAHuman("Shinobi Tengu", "DarkStorm.rte");
	pl.AIMode = Actor.AIMODE_SENTRY;
	pl.Team = 0;
	pl:AddInventoryItem(CreateHDFirearm("D17 Pistol", "DarkStorm.rte"));
	pl:AddInventoryItem(CreateHDFirearm("D35 Carbine", "DarkStorm.rte"));
	pl:AddInventoryItem(CreateTDExplosive("Frag Grenade", "Coalition.rte"));
	pl:AddInventoryItem(CreateTDExplosive("P.A. Frag Nade", "PelianArmy.rte"));
	pl:AddInventoryItem(CreateTDExplosive("P.A. Plasma Nade", "PelianArmy.rte"));
	pl.Pos = Vector(79,429);
	MovableMan:AddActor(pl)

	playerActor = pl;
	self:SetPlayerBrain(playerActor, player);
	self:SetLandingZone(playerActor.Pos, player);
	
	end
    	
	target = CreateAHuman("Ronin Soldier 1", "Ronin.rte");
	target.AIMode = Actor.AIMODE_SENTRY;
	target.Team = 1;
	target:AddInventoryItem(CreateHDFirearm("Pistol"));
	target.Pos = Vector(3280, 336);
	MovableMan:AddActor(target);
	
	target2 = CreateAHuman("Ronin Soldier 1", "Ronin.rte");
	target2.AIMode = Actor.AIMODE_SENTRY;
	target2.Team = 1;
	target2:AddInventoryItem(CreateHDFirearm("Pistol"));
	target2.Pos = Vector(879, 638);
	MovableMan:AddActor(target2);

    self.AreaTimer:Reset();
    self.StepTimer:Reset();
    self.SpawnTimer:Reset();
	
	FrameMan:SetScreenText("Objective Update: assassinate the ronin leader (blonde, male)", Activity.PLAYER_1, 0, 10000, false);
end

-----------------------------------------------------------------------------------------
-- Pause Activity
-----------------------------------------------------------------------------------------

function AssassinationMission:PauseActivity(pause)
    print("PAUSE! -- AssassinationMission:PauseActivity()!");
end

-----------------------------------------------------------------------------------------
-- End Activity
-----------------------------------------------------------------------------------------

function AssassinationMission:EndActivity()
	print("END! -- AssassinationMission:EndActivity()!");
	--End the game.

	--These are all done after the mission ends, because otherwise they are replaced with "Lost control of remote body!" or "Returned craft and contents for X funds."
	if self.WinnerTeam == Activity.TEAM_1 then
		self:ResetMessageTimer(Activity.PLAYER_1);
            	FrameMan:ClearScreenText(Activity.PLAYER_1);
		FrameMan:SetScreenText("MISSION COMPLETE!", Activity.PLAYER_1, 0, 5000, false);
	end
end

-----------------------------------------------------------------------------------------
-- Update Activity-----------------------------------------------------------------------------------------

function AssassinationMission:UpdateActivity()
	if varend == 0 and MovableMan:IsActor(playerActor) then
		-- Odd need for a delay here, probably to allow actors to spawn
		if self.timer == 30 then

			--Set everyone to sentry mode so they don't wander.
			for actor in MovableMan.Actors do
				-- Set all actors to sentry AI mode
             		   	actor:SetControllerMode(Controller.CIM_AI, -1);
             		   	actor.AIMode = Actor.AIMODE_SENTRY;
        	end

			--Switch to the player.  The computer thinks it's switched, but it actually isn't in control.
			self:SwitchToActor(playerActor, 0, self:GetTeamOfPlayer(0));
		end
		
		--Update the timer.
		self.timer = self.timer + 1;
		local player = 0;
        local team = self:GetTeamOfPlayer(player);
	
		--Make sure the focus is always on playerActor.
		if MovableMan:IsActor(playerActor) then
			if self:GetControlledActor(Activity.PLAYER_1) == nil then
				self:SwitchToActor(playerActor, player, team);
			else
				local pid = self:GetControlledActor(Activity.PLAYER_1).ID;
				if playerActor.ID ~= pid then
					self:SwitchToActor(playerActor, player, team);
				end
			end
		end
			
		-- The targets has been assassinated
		if((not MovableMan:IsActor(target)) and assassinated == 0) then
			print("target1 is down");
			assassinated = 1;
			if assassinated2 == 0 and assassinated == 1 then
				FrameMan:ClearScreenText(Activity.PLAYER_1);
				FrameMan:SetScreenText("Objective: assassinate the last target", Activity.PLAYER_1, 0, 10000, false);
			end
			else if assassinated2 == 1 and assassinated == 1 then
				FrameMan:ClearScreenText(Activity.PLAYER_1);
				FrameMan:SetScreenText("Head for the exit in the underground tunnel to the east", Activity.PLAYER_1, 0, 10000, false);
			end
		end
		if((not MovableMan:IsActor(target2)) and assassinated2 == 0) then
			print("target2 is down");
			assassinated2 = 1;
			if assassinated == 0 and assassinated2 == 1 then
				FrameMan:ClearScreenText(Activity.PLAYER_1);
				FrameMan:SetScreenText("Objective: assassinate the last target", Activity.PLAYER_1, 0, 10000, false);
			end
			else if assassinated == 1 and assassinated2 == 1 then
				FrameMan:ClearScreenText(Activity.PLAYER_1);
				FrameMan:SetScreenText("Head for the exit in the underground tunnel to the east", Activity.PLAYER_1, 0, 10000, false);
			end
		end
				
		if (not self.playerswitched and MovableMan:IsActor(playerActor)) then
			-- Switch to the new player
			self:SwitchToActor(playerActor, player, self:GetTeamOfPlayer(player));
			self.playerswitched = true;
			self:ResetMessageTimer(Activity.PLAYER_1);
            FrameMan:ClearScreenText(Activity.PLAYER_1);
		end

		--Once everything is spawned, check if the player has completed any objectives.
		if self.timer > 50 and MovableMan:IsActor(playerActor) then
			--Check if the player is within the prison cell.  If they are, remind them of the current objective.
			if escape:IsInside(playerActor.Pos) and assassinated == 1 and assassinated2 == 1 then
				self.WinnerTeam = Activity.TEAM_1;
				ActivityMan:EndActivity();
			end
			else if escape:IsInside(playerActor.Pos) then
				FrameMan:SetScreenText("What are you doing? assassinate the targets, soldier!", Activity.PLAYER_1, 0, 10000, false);
			end
		end
		
		
		if MovableMan:IsActor(playerActor) then
			--If the player is alive, set its last position to this number.
			lastpos = playerActor.Pos;
			--Set the observation target, or what the game flies to when the game ends, to the player's last position.  Now do you see why we use the last position and not the current one?  If the game is over, there IS no player.
            self:SetObservationTarget(lastpos, Activity.PLAYER_1);
		end
	end
	if varend == 0 and not MovableMan:IsActor(playerActor) then
		-- game over
		self.playerswitched = false;
		self.WinnerTeam = Activity.TEAM_2;
		varend = 1;
		
		ActivityMan:EndActivity();
	end
end
